#ifndef LIB_GEN_H
//#define LIB_GEN_H

#define F_CPU 16000000L
#include <stdint-gcc.h>
#include <util/delay.h>
#define boolean int
#define true 1
#define false 0

#define TFTWIDTH  128
#define TFTHEIGHT_18  160
#define WIDTH TFTWIDTH;
#define HEIGHT TFTHEIGHT_18;
#include <avr/pgmspace.h>

#define INITR_18GREENTAB    INITR_GREENTAB
#define INITR_18REDTAB      INITR_REDTAB
#define INITR_18BLACKTAB    INITR_BLACKTAB
#define INITR_144GREENTAB   0x1

#define TFTWIDTH  128
// for 1.8" display
#define TFTHEIGHT_18  160

#define NOP     0x00
#define SWRESET 0x01
#define RDDID   0x04
#define RDDST   0x09

#define SLPIN   0x10
#define SLPOUT  0x11
#define PTLON   0x12
#define NORON   0x13

#define INVOFF  0x20
#define INVON   0x21
#define DISPOFF 0x28
#define DISPON  0x29
#define CASET   0x2A
#define RASET   0x2B
#define RAMWR   0x2C
#define RAMRD   0x2E

#define PTLAR   0x30
#define COLMOD  0x3A
#define MADCTL  0x36

#define FRMCTR1 0xB1
#define FRMCTR2 0xB2
#define FRMCTR3 0xB3
#define INVCTR  0xB4
#define DISSET5 0xB6

#define PWCTR1  0xC0
#define PWCTR2  0xC1
#define PWCTR3  0xC2
#define PWCTR4  0xC3
#define PWCTR5  0xC4
#define VMCTR1  0xC5

#define RDID1   0xDA
#define RDID2   0xDB
#define RDID3   0xDC
#define RDID4   0xDD

#define PWCTR6  0xFC

#define GMCTRP1 0xE0
#define GMCTRN1 0xE1

// Color definitions
#define	BLACK   0x0000
#define	BLUE    0x001F
#define	RED     0xF800
#define	GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

/* Configurarea SPI */
#define SPI_PORT	PORTB
#define SPI_DDR		DDRB
#define SPI_RST		PB3 //not used yet
#define SPI_DC		PB2
#define SPI_MOSI	PB5
#define SPI_SCK		PB7
#define SPI_CS1		PB4
#define SPI_CS2		PB1

#define SLAVE1	1
#define SLAVE2  2

#define CS_DESELECT1()	SPI_PORT |=  (1<<SPI_CS1)	/* SD CS1 = 1 */
#define CS_DESELECT2()	SPI_PORT |=  (1<<SPI_CS2)	/* SD CS2 = 1 */

#define RS_SELECT()		SPI_PORT &= ~(1<<SPI_DC)	/* SD RS = 0 */
#define RS_DESELECT()	SPI_PORT |=  (1<<SPI_DC)	/* SD RS = 1 */


uint8_t  tabcolor;
uint8_t colstart, rowstart; // some displays need this changed



#define swap(a, b) { int16_t t = a; a = b; b = t; }
  // This is the 'raw' display w/h - never changes
	int16_t
	_width, _height, // Display w/h as modified by current rotation
	cursor_x, cursor_y;
	uint16_t
	textcolor, textbgcolor;
	uint8_t
	textsize,
	rotation;
	boolean
	wrap; // If set, 'wrap' text at right edge of display

	void Adafruit_GFX(); // Constructor

	// This MUST be defined by the subclass:
	void drawPixel(int16_t x, int16_t y, uint16_t color, int slave_id);

	// These MAY be overridden by the subclass to provide device-specific
	// optimized code.  Otherwise 'generic' versions are used.
	void drawLine(int16_t x0, int16_t y0, int16_t x1, int16_t y1, uint16_t color, int slave_id);
	void drawRect(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color, int slave_id);

	// These exist only with Adafruit_GFX (no subclass overrides)
	void drawCircle(int16_t x0, int16_t y0, int16_t r, uint16_t color, int slave_id);
	void drawCircleHelper(int16_t x0, int16_t y0, int16_t r, uint8_t cornername, uint16_t color, int slave_id);
	void fillCircle(int16_t x0, int16_t y0, int16_t r, uint16_t color, int slave_id);
	void fillCircleHelper(int16_t x0, int16_t y0, int16_t r, uint8_t cornername, int16_t delta, uint16_t color, int slave_id);
	void drawTriangle(int16_t x0, int16_t y0, int16_t x1, int16_t y1, int16_t x2, int16_t y2, uint16_t color, int slave_id);
	void fillTriangle(int16_t x0, int16_t y0, int16_t x1, int16_t y1, int16_t x2, int16_t y2, uint16_t color, int slave_id);
	void drawRoundRect(int16_t x0, int16_t y0, int16_t w, int16_t h, int16_t radius, uint16_t color, int slave_id);
	void fillRoundRect(int16_t x0, int16_t y0, int16_t w, int16_t h, int16_t radius, uint16_t color, int slave_id);
	void drawBitmap(int16_t x, int16_t y, const uint8_t *bitmap, int16_t w, int16_t h, uint16_t color, int slave_id);
	void drawBitmapBg(int16_t x, int16_t y, const uint8_t *bitmap, int16_t w, int16_t h, uint16_t color, uint16_t bg, int slave_id);
	void drawXBitmap(int16_t x, int16_t y, const uint8_t *bitmap, int16_t w, int16_t h, uint16_t color, int slave_id);
	void drawChar(int16_t x, int16_t y, unsigned char c, uint16_t color, uint16_t bg, uint8_t size, int slave_id);
	void setCursor(int16_t x, int16_t y, int slave_id);
	void setTextColor(uint16_t c, int slave_id);
	void setTextColorBg(uint16_t c, uint16_t bg, int slave_id);
	void setTextSize(uint8_t s, int slave_id);
	void setTextWrap(boolean w, int slave_id);

	void write(uint8_t, int slave_id);

	int16_t height(void);
	int16_t width(void);

	uint8_t getRotation(void);

	void     spiwrite(uint8_t),
	writecommand(uint8_t c, int slave_id),
	writedata(uint8_t d, int slave_id),
	commandList(const uint8_t *addr, int slave_id),
	commonInit(const uint8_t *cmdList);
	
	void initB(void);                             // for ST7735B displays
	void initR(void);					// for ST7735R
	void setAddrWindow(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1, int slave_id);
	void pushColor(uint16_t color, int slave_id);
	void fillScreen(uint16_t color, int slave_id);
	void drawPixel(int16_t x, int16_t y, uint16_t color, int slave_id);
	void drawFastVLine(int16_t x, int16_t y, int16_t h, uint16_t color, int slave_id);
	void drawFastHLine(int16_t x, int16_t y, int16_t w, uint16_t color, int slave_id);
	void fillRect(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color, int slave_id);
	void setRotation(uint8_t r, int slave_id);
	void invertDisplay(boolean i, int slave_id);
	uint16_t Color565(uint8_t r, uint8_t g, uint8_t b);
#endif // _ADAFRUIT_GFX_H
